_EVENMOAR/USERS/DANIELRES/distinctions-fines/config/routes.rb
DistinctionsFines::Application.routes.draw do

  resources :authentications

    match '/signout' => 'sessions#destroy', :as => :signout
    match '/signin' => 'sessions#new', :as => :signin
    match '/users/auth/:provider/callback' => 'authentications#create'          
    match '/auth/failure' => 'sessions#failure'

  devise_for :users, :controllers => { :omniauth_callbacks => "authentications"}

  mount RailsAdmin::Engine => '/admin', :as => 'rails_admin'

  resources :users

  resources :articles
  
  resources :comments  
  

  root :to => 'blog#index'

end

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :token_authenticatable, :encryptable, :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable,
         :omniauthable


  # Setup accessible (or protected) attributes for your model
  attr_accessible :display_name, :email, :password, :password_confirmation, :remember_me
  
  
  has_many :articles, :foreign_key => :author_id
  
  validates :display_name, :email, :presence => true

  has_many :authentications


  
  
  def to_s
    display_name
  end
  
  def has_role?(role)
    if role == :admin
      true if id == 2
    end
  end
  
end

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/controllers/users_controller.rb
class UsersController < ApplicationController

  load_and_authorize_resource  
  # GET /users
  # GET /users.json
  def index

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @users }
    end
  end

  # GET /users/1
  # GET /users/1.json
  def show

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @user }
    end
  end

  # GET /users/new
  # GET /users/new.json
  def new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @user }
    end
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: 'User was successfully created.' }
        format.json { render json: @user, status: :created, location: @user }
      else
        format.html { render action: "new" }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /users/1
  # PUT /users/1.json
  def update

    respond_to do |format|
      if @user.update_attributes(params[:user])
        format.html { redirect_to @user, notice: 'User was successfully updated.' }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy

    respond_to do |format|
      format.html { redirect_to users_url }
      format.json { head :ok }
    end
  end
end

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/helpers/users_helper.rb
module UsersHelper
end

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/views/users/_form.html.haml
= form_for @user do |f|
  -if @user.errors.any?
    #error_explanation
      %h2= "#{pluralize(@user.errors.count, "error")} prohibited this user from being saved:"
      %ul
        - @user.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :display_name
    = f.text_field :display_name

  .field
    = f.label :password
    = f.password_field :password

  .actions
    = f.submit 'Save'

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/views/users/edit.html.haml
%h1 Update my details

%hr

= render 'form'

%hr 

%ul
  %li= link_to 'See my profile', @user
  %li= link_to 'Manage authentication options', authentications_path

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/views/users/index.html.haml
%h1 Listing users

%table
  %tr
    %th Display name
    %th Created at
    %th Updtated at
    %th
    %th
    %th

  - @users.each do |user|
    %tr
      %td= user.display_name
      %td= user.created_at
      %td= user.updtated_at
      %td= link_to 'Show', user
      %td= link_to 'Edit', edit_user_path(user)
      %td= link_to 'Destroy', user, :confirm => 'Are you sure?', :method => :delete

%br

= link_to 'New User', new_user_path

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/views/users/new.html.haml
%h1 New user

= render 'form'

= link_to 'Back', users_path

_EVENMOAR/USERS/DANIELRES/distinctions-fines/app/views/users/show.html.haml
%p#notice= notice

%h2
  Public profile: 
  =@user.display_name
%hr
%p
  %b Display name:
  = @user.display_name
%p
  %b Created at:
  = @user.created_at
%p
  %b Updtated at:
  = @user.updtated_at


-if can? :update, @user
  %hr
    %ul
      %li= link_to 'Update my details', edit_user_path(@user)